package rwth.i2.ltlrv.afastate.impl;


import java.util.Set;

import rwth.i2.ltlrv.afastate.base.NullaryAFAState;
import rwth.i2.ltlrv.afastate.interfaze.IAFAState;
import rwth.i2.ltlrv.afastate.interfaze.IFF;
import rwth.i2.ltlrv.data.PropositionSet;
import rwth.i2.ltlrv.data.WeakValuesMap;

/**
 * FF - Implements the sink state / formula representing <code>false</code>. 
 * 
 * @author Eric Bodden
 */
public class FF extends NullaryAFAState implements IFF {

    /**
     * {@inheritDoc}
     */
    public boolean isFinalStateInAFA() {
        //FF is nonfinal per definition
        return false;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings("unused")
    public void doTransition(Set<String> context, PropositionSet currentProps, WeakValuesMap<String, Object> currentBinding, Set<Set<IAFAState>> result) {
        //FF is represented by the empty set, so simply add nothing
    }

    /**
     * {@inheritDoc}
     */
    public String symbol() {
        return "FF";
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean equals(Object obj) {
        return obj instanceof IFF;
    }
    
}
