package rwth.i2.ltlrv.formula.base;

import rwth.i2.ltlrv.formula.interfaze.IFormula;
import rwth.i2.ltlrv.formula.interfaze.IUnaryTerm;

/**
 * BinaryFormula - Abstract superclass of all unary formulae.
 * 
 * @author Eric Bodden
 */
public abstract class UnaryFormula extends AbstractFormula implements IUnaryTerm {

    /** the subformula */
    protected IFormula subformula;
    
    /**
     * @param subformula the subformula
     */
    public UnaryFormula(IFormula subformula) {
        this.subformula = subformula;
    }
    
    /**
     * {@inheritDoc}
     */
    public IFormula getSubformula() {
        return subformula;
    }
    
    /**
     * {@inheritDoc}
     */
    @Override
    //simply recurse
    public String toString() {
        return this.symbol() +
            "(" +
            this.subformula.toString() +
            ")";
    }    
}
