package rwth.i2.ltlrv.management;


/**
 * EvalGlobalImplicationSamePropositionTest
 * 
 * @author Eric Bodden
 */
@SuppressWarnings("all")
public class EvalGlobalImplicationSamePropositionTest extends EvalAbstractEvaluationTest {

    public EvalGlobalImplicationSamePropositionTest() {
        super( f.G(f.Impl(p_a,f.X(f.F(p_b)))) ); 
    }
    
    public void testSimpleSequential() {
        assertTrue(config.isFinal());

        props.add(f.Proposition("p",bindings_actual_a_1));
        config.transition(props);
        assertFalse(config.isFinal());
        
        props.clear();
        
        props.add(f.Proposition("p",bindings_actual_b_1));
        config.transition(props);
        assertTrue(config.isFinal());
    }
    
    public void testBothSequential() {
        assertTrue(config.isFinal());

        props.add(f.Proposition("p",bindings_actual_a_1));
        props.add(f.Proposition("p",bindings_actual_b_1));
        config.transition(props);
        assertFalse(config.isFinal());

        props.clear();

        props.add(f.Proposition("p",bindings_actual_a_1));
        config.transition(props);
        assertFalse(config.isFinal());
        
        props.clear();

        props.add(f.Proposition("p",bindings_actual_b_1));
        config.transition(props);
        assertTrue(config.isFinal());
    }
}
