package rwth.i2.ltlrv.management;


/**
 * EvalPropositionTest
 * 
 * @author Eric Bodden
 */
@SuppressWarnings("all")
public class EvalPropositionTest extends EvalAbstractEvaluationTest {

    public EvalPropositionTest() {
        super( p_a ); 
    }
    
    public void testPositive() {
        assertFalse(config.isFinal());

        props.add(f.Proposition("p",bindings_actual_a_1));
        config.transition(props);
        assertTrue(config.isFinal());
    }    

    public void testWrongProposition() {
        assertFalse(config.isFinal());

        props.add(f.Proposition("q",bindings_actual_a_1));
        config.transition(props);
        assertFalse(config.isFinal());
    }    
    
    public void testWrongArgument() {
        assertFalse(config.isFinal());

        props.add(f.Proposition("p",bindings_actual_b_1));
        config.transition(props);
        assertFalse(config.isFinal());
    }
    
    public void testUnbound() {
        assertionCheck();
    	
    	assertFalse(config.isFinal());

        props.add( p_a );
        try {
            config.transition(props);
            //a is unbound, which is invalid
            //this should be caught
            fail();
        } catch(AssertionError e) {
        }
    }

	private void assertionCheck() {
		boolean ea = false;
        assert ea = true;
        
        if(!ea) {
        	fail("Assertions must be enable in order to execute this test.");
        }
	}    
    
    public void testUnboundWrongArgument() {
        assertFalse(config.isFinal());

        props.add( p_b );
        config.transition(props);
        assertFalse(config.isFinal());
    } 

    public void testUnboundWrongProposition() {
        assertFalse(config.isFinal());

        props.add( q_a );
        config.transition(props);
        assertFalse(config.isFinal());
    } 
}
