package rwth.i2.ltlrv.management;

import rwth.i2.ltlrv.afastate.interfaze.IProposition;
import rwth.i2.ltlrv.data.WeakValuesHashMap;
import rwth.i2.ltlrv.data.WeakValuesMap;


/**
 * EvalPropositionTest
 * 
 * @author Eric Bodden
 */
@SuppressWarnings("all")
public class EvalPropositionWeakMapTest extends EvalAbstractEvaluationTest {

    protected final static WeakValuesMap<String,Object> bindings_weak_actual = new WeakValuesHashMap<String, Object>();
    
    protected final static IProposition p_w;

    protected /*nonfinal*/ static Integer weak_actual_w = new Integer(1);

    static {
        bindings_weak_actual.put("w",weak_actual_w);
        p_w = f.Proposition("p","w").specializeBindings(bindings_weak_actual);
    }    
    
    public EvalPropositionWeakMapTest() {
        super( f.F(p_w) ); 
    }
    
    public void testNormalMatching() {
        assertFalse(config.isFinal());

        props.add( p_w );
        config.transition(props);
        assertTrue(config.isFinal());        
    }

    public void testGC() {
        assertFalse(config.isFinal());

        props.add( p_w );
        
        //GC:
        //remove the last strong reference
        weak_actual_w = null;
        //perform garbage collection
        System.gc();
        //
        
        config.transition(props);
        assertFalse(config.isFinal());        
    }
}
